#include <mex.h>
#include <stdarg.h>

//#define PRINT

void Print( const char* format, ... )
{
#ifdef PRINT
	char buffer[256];
	va_list args;
	va_start (args, format);
	vsprintf(buffer, format, args);
	va_end (args);
	mexPrintf("%s", buffer);
	mexEvalString("drawnow;"); // to print string.
#endif
}

void compNLweights(int iNy, int iNx, int im, int iw, float fh, int iNbNeigh, int iIncludeCloseNeigh, int nThreads,
				   float * pfIm0, 
				   float * pfW, int* piY, int* piSizeNeigh, float* pfWmat, int* piYmat);

extern void mexFunction(int iNbOut, mxArray *pmxOut[], int iNbIn, const mxArray *pmxIn[])
{
	
	float * pfIm0 = (float*)mxGetData(pmxIn[0]);
    
    float * pfVecGeneralParameters = (float*)mxGetData(pmxIn[1]);
    
    int iNy      = (int) pfVecGeneralParameters[0];
    int iNx      = (int) pfVecGeneralParameters[1];
    int im       = (int) pfVecGeneralParameters[2];
    int iw       = (int) pfVecGeneralParameters[3];
    float fh     = pfVecGeneralParameters[4];
    int iNbNeigh = (int) pfVecGeneralParameters[5];
    int iIncludeCloseNeigh = (int) pfVecGeneralParameters[6];
	int nThreads = (int) pfVecGeneralParameters[7];
    Print("iNy= %i, iNx= %i, im= %i, iw= %i, fh= %.3f\n",iNy,iNx,im,iw,fh);

	int iN3;
    int iNdim;
    mwSize iDim[3];

	iN3 = iNbNeigh* 2* 2;
	iNdim = 3;
	iDim[0] = iNx;
    iDim[1] = iNy;
    iDim[2] = iN3;
    pmxOut[0] = mxCreateNumericArray(iNdim,iDim,mxSINGLE_CLASS,mxREAL);
    float* pfW = (float*)mxGetData(pmxOut[0]);
    
    
    iN3 =iNbNeigh* 2* 2;
    iNdim = 3;
    iDim[0] = iNx;
    iDim[1] = iNy;
    iDim[2] = iN3;
    pmxOut[1] = mxCreateNumericArray(iNdim,iDim,mxINT32_CLASS,mxREAL);
    int* piY = (int*)mxGetData(pmxOut[1]);
    
    
    iNdim = 2;
    iDim[0] = iNx;
    iDim[1] = iNy;
    pmxOut[2] = mxCreateNumericArray(iNdim,iDim,mxINT32_CLASS,mxREAL);
    int* piSizeNeigh = (int*)mxGetData(pmxOut[2]);
    
    
    iN3 =iNbNeigh* 2* 2;
    iNdim = 3;
    iDim[0] = iNx;
    iDim[1] = iNy;
    iDim[2] = iN3;
    pmxOut[3] = mxCreateNumericArray(iNdim,iDim,mxSINGLE_CLASS,mxREAL);
    float* pfWmat = (float*)mxGetData(pmxOut[3]);
    
    pmxOut[4] = mxCreateNumericArray(iNdim,iDim,mxINT32_CLASS,mxREAL);
    int* piYmat = (int*)mxGetData(pmxOut[4]);

	compNLweights(iNy, iNx, im, iw, fh, iNbNeigh, iIncludeCloseNeigh, nThreads,
				  pfIm0, 
				  pfW, piY, piSizeNeigh, pfWmat, piYmat);
}